#include "etherxd.h"
#include "dlfcn.h"

/* internal lookup table for matching hosts/namespaces to delivery points */

edb db(int cmd, char *host, char *namespace)
{
    static edb d = NULL;
    edb next, prev;

    if(host == NULL || namespace == NULL);

    switch(cmd)
    {
        case CMD_SET:
            debug("db(SET,%s,%s)",host,namespace);
            db(CMD_DEL,host,namespace);
            next = malloc(sizeof(_edb));
            next->host = j_strdup(host);
            next->namespace = j_strdup(namespace);
            next->t = NULL;
            next->dso_handler = NULL;
            next->next = d;
            d = next;
            return next;
            break;
        case CMD_GET:
            debug("db(GET,%s,%s)",host,namespace);
            next = d;
            while(next != NULL)
            {
                if(j_strcmp(host,next->host) == 0 && j_strcmp(namespace,next->namespace) == 0)
                    return next;
                next = next->next;
            }
            break;
        case CMD_DEL:
            debug("db(DEL,%s,%s)",host,namespace);
            prev = next = d;
            while(next != NULL)
            {
                if(j_strcmp(host,next->host) == 0 && j_strcmp(namespace,next->namespace) == 0)
                {
                    if(next == d)
                        d = next->next;
                    else
                        prev->next = next->next;
                    free(next->host);
                    free(next->namespace);
                    free(next);
                    return NULL;
                }
                prev = next;
                next = next->next;
            }

    }
    return NULL;
}
