#include "etherxd.h"

/* code for an etherx daemon
    - loads config file
    - error and connection log file
    - DSO loads transports
    - listens on sockets and manages connections
    - routes epackets between connections and transports
*/

xmlnode config = NULL;

int main(int argc, char *argv[])
{
    pth_event_t sigevt;
    sigset_t set;
    int sig;

    /* check for command line help flags and print out help screen */
	
    jlib_init(LOG2_NONE, NULL);

    registry_load();

    logger_init();
    dso_init();
    net_init();

    sigemptyset(&set);
    sigaddset(&set, SIGUSR1);
    pth_sigmask(SIG_UNBLOCK, &set, NULL);
    sigevt = pth_event(PTH_EVENT_SIGS, &set, &sig);

    /* main thread, wait on restart/kill signals and react appropriately */
    debug("Main loop waiting");
    while (1)
    {
        pth_wait(sigevt);
        debug("Got SIGUSR1 in main loop");
    }            
    return 0;
}

