#include <jabber/jlib.h>
#include "etherx.h"

#define CMD_SET 0
#define CMD_GET 1
#define CMD_DEL 2
 
#define DB_CONNECTION 0
#define DB_TRANSPORT 1
#define DB_ERROR 2

extern xmlnode config;

typedef struct edb_struct
{
    int type;
    char *host;
    char *namespace;
    void (*dso_handler)(epacket e); /* used if it's a dso transport */
    thread t; /* used if it's an xml stream */
    struct edb_struct *next;
} _edb, *edb;
 
edb db(int cmd, char *host, char *namespace);

void net_init();
void net_init_listen(xmlnode x);
void net_negotiate(thread t, xmlnode in, int type);
void net_onConnect(thread t, int sock, struct sockaddr_in sa);
void net_onNode(thread t, xmlnode in, int type);

void manager_send(epacket e);
void manager_deliver(edb d, epacket e);                                                                                    

/* connection management */
void transport_onNode(thread t, xmlnode in, int type); /* from socket transports */
void transport_deliver_onNode(thread t, xmlnode in, int type); /* from connections to a transport */
void transport_send(epacket e);
void transport_cleanup(void *arg);

void dso_init();
void dso_init_load(xmlnode x);
void *dso_open(char *so);
void *dso_sym(void *so, char *func);
void dso_alias(void (*handler)(epacket e), char *host, char *namespace);

