
#define ETHERX_NAMESPACE "http://etherx.jabber.org/"

typedef struct epacket_struct
{
    xmlnode x;
    char *to;
    char *from;
    char *ns;
    char *error;
    int type;
} _epacket, *epacket;

#define EPACKET_UNKNOWN -1
#define EPACKET_NORMAL 0 /* default */
#define EPACKET_REGISTRY 1 /* special flag that this is a registry packet */
#define EPACKET_ERROR 2 /* special flag that this is an error/bounced packet */
#define EPACKET_ALIAS 3 /* this is a special packet that identifies a host alias for a transport */
#define EPACKET_TRANSPORT 4 /* transport's identification phase */

/* public functions */
void etherx_send(epacket e); /* sends epacket to etherx */
void etherx_alias(char *host); /* adds host alias for this transport to receive incoming data on */
epacket epacket_new(xmlnode x, char *to, char *from, char *ns); /* if to/from are null it extracts them from x, sets type based on element name */
void epacket_error(epacket e, char *error); /* simply turns a normal epacket into an error one */

/* socket based transport */
int etherx_init(char *id, char *secret, char *host, char *namespace, void (*receive)(epacket e));

/* dso stuff for etherxd */
void _etherx_setup(void *send, void *receive, void *alias, char *namespace); /* called by etherxd from within each dso to setup etherxd internal pointers/data */

/* internal functions */
void _etherx_receive(thread t, xmlnode x, int flag); /* callback for xmlstream when doing socket connects */
void _etherx_cleanup(void *arg); /* attempts to reconnect to etherxd */
