#include <jabber/jlib.h>
#include "etherx.h"

/* code to abstract the sending of epackets to etherx either via memory or sockets */

/* from socket.c */
extern thread _etherx_thread;
extern void (*_etherx_receive_handler)(epacket e);
extern char *_etherx_namespace;

void (*_etherx_send_handler)(epacket e);
void (*_etherx_alias_handler)(void (*handler)(epacket e), char *host, char *namespace);

void etherx_send(epacket e)
{

    if(_etherx_thread != NULL)
    { /* use the socket */
        debug("etherx_send: socket");
        xmlnode_put_attrib(e->x, "etherx:to", e->to);
        xmlnode_put_attrib(e->x, "etherx:from", e->from);
        xmlstream_write(_etherx_thread, e->x);
    }else{ /* we're dso'd in the same process, send to etherxd */
        debug("etherx_send: dso");
        e->ns = pstrdup(xmlnode_pool(e->x), _etherx_namespace); /* set the transports namespace */
        (*_etherx_send_handler)(e);
    }
}

void etherx_alias(char *host)
{
    xmlnode x;

    if(host == NULL)
        return;

    if(_etherx_thread != NULL)
    { /* use the socket */
        debug("etherx_alias: socket");
        x = xmlnode_new_tag("etherx:alias");
        xmlnode_insert_cdata(x, host, strlen(host));
        xmlstream_write(_etherx_thread, x);
    }else{ /* we're dso'd in the same process, send to etherxd */
        debug("etherx_alias: dso");
        (*_etherx_alias_handler)(_etherx_receive_handler, host, _etherx_namespace);
    }
}

/* called within dso by etherxd to set etherxd handlers/data */
void _etherx_setup(void *send, void *receive, void *alias, char *namespace)
{
    _etherx_send_handler = send;
    _etherx_receive_handler = receive;
    _etherx_alias_handler = alias;
    _etherx_namespace = j_strdup(namespace);
}
